/*###############################################################################
# Linux Management Providers (LMP), Power Management provider package
# Copyright (C) 2009 Shakhrom RUSTAMOV, TUIT <shahrombek@gmail.com>
#
# This program is being developed under the "OpenDRIM" project.
# The "OpenDRIM" project web page: http://opendrim.sourceforge.net
# The "OpenDRIM" project mailing list: opendrim@googlegroups.com
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; version 2
# of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#################################################################################

#################################################################################
# To contributors, please leave your contact information in this section
# AND comment your changes in the source code.
#
# Modified by 2010 Guillaume BOTTEX, ETRI <guillaumebottex@etri.re.kr>
###############################################################################*/

#ifndef OPENDRIM_POWERMANAGEMENTSERVICECAPABILITIESACCESS_H_
#define OPENDRIM_POWERMANAGEMENTSERVICECAPABILITIESACCESS_H_

#include "PowerManagement_Common.h"

#include "OpenDRIM_PowerManagementServiceCapabilities.h"
#include "assocOpenDRIM_PowerManagementServiceCapabilities.h"

int PowerManagement_OpenDRIM_PowerManagementServiceCapabilities_load(const CMPIBroker* broker, string& errorMessage);

int PowerManagement_OpenDRIM_PowerManagementServiceCapabilities_unload(string& errorMessage);

int PowerManagement_OpenDRIM_PowerManagementServiceCapabilities_retrieve(const CMPIBroker* broker, const CMPIContext* ctx, vector<OpenDRIM_PowerManagementServiceCapabilities>& instances, const char** properties, string& errorMessage, const string& discriminant);

int PowerManagement_OpenDRIM_PowerManagementServiceCapabilities_getInstance(const CMPIBroker* broker, const CMPIContext* ctx, OpenDRIM_PowerManagementServiceCapabilities& instance, const char** properties, string& errorMessage);

int PowerManagement_OpenDRIM_PowerManagementServiceCapabilities_setInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_PowerManagementServiceCapabilities& newInstance, const OpenDRIM_PowerManagementServiceCapabilities& oldInstance, const char** properties, string& errorMessage);

int PowerManagement_OpenDRIM_PowerManagementServiceCapabilities_createInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_PowerManagementServiceCapabilities& instance, string& errorMessage);

int PowerManagement_OpenDRIM_PowerManagementServiceCapabilities_deleteInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_PowerManagementServiceCapabilities& instance, string& errorMessage);

int PowerManagement_OpenDRIM_PowerManagementServiceCapabilities_associatorCapabilitiesToManagedElement(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& Capabilities_instance, const char** properties, vector<Instance>& ManagedElement_associatedInstances, string& errorMessage, const string& discriminant);

int PowerManagement_OpenDRIM_PowerManagementServiceCapabilities_associatorManagedElementToCapabilities(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& ManagedElement_instance, const char** properties, vector<Instance>& Capabilities_associatedInstances, string& errorMessage, const string& discriminant);

int PowerManagement_OpenDRIM_PowerManagementServiceCapabilities_referenceCapabilitiesToManagedElement(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& Capabilities_instance, const vector<Instance>& ManagedElement_instances, vector<OpenDRIM_PowerManagementServiceCapabilities>& OpenDRIM_PowerManagementServiceCapabilities_instances, const char** properties, string& errorMessage, const string& discriminant);

int PowerManagement_OpenDRIM_PowerManagementServiceCapabilities_referenceManagedElementToCapabilities(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& ManagedElement_instance, const vector<Instance>& Capabilities_instances, vector<OpenDRIM_PowerManagementServiceCapabilities>& OpenDRIM_PowerManagementServiceCapabilities_instances, const char** properties, string& errorMessage, const string& discriminant);

int PowerManagement_OpenDRIM_PowerManagementServiceCapabilities_populate(OpenDRIM_PowerManagementServiceCapabilities& instance, string& errorMessage);

#endif /*OPENDRIM_POWERMANAGEMENTSERVICECAPABILITIESACCESS_H_*/
